/*	******************************************************************
	CONTINUE STATEMENT
	******************************************************************
	-	Demonstrating the usage of the Continue Statement in C++
		-	This forces moving on to the next Iteration regardless of 
			what is left in the current iteration		
	-	In this case, it is called inside a for loop
		-	In each Iteration, the section which is to display
			"Finishing iteration " is never reached
	-	NB This is for demonstration purposes only
		-	It is bad practice to write code which forces a part 
			never to be reached
		-	Better to do it inside a conditional statement
*/
#include <iostream>
using namespace std;

int main( )
{
	//
	for( int i = 0; i < 12; ++i )
	{
		cout << "Starting iteration " << i << endl;
		continue;

		// This section is never reached
		cout << "Finishing iteration " << i << endl;	
	}

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << endl << "END...C++ Demo Continue statement" << endl
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
