/*	******************************************************************
	STATIC Local Variables
	******************************************************************
	-	This program shows how to implement and use
		STATIC Local Variables
		-	i.e. Variables which retain their value between
			function calls
*/
#include <iostream>
using namespace std;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Function DECLARATION
//
void greet_English();


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int main()
{
	for( int i = 0; i < 10; ++i )
	{
		greet_English();
	}

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Functions, Static Local Variable" 
		 << " " 
		 << endl;
	while(true){} 
	return 0;

}//END...Function MAIN


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Function DEFINITIONS
//
void greet_English()
{
	// STATIC Local Variable
	// -	Set to 0 only on the FIRST call
	// -	Retains its value between calls thereafter
	//
	static int num_TimesCalled = 0;

	// Increments every time the function is called
	++num_TimesCalled;

	cout << "Hello, how are you?" << endl;
	cout << "This function has been called " 
		 << num_TimesCalled << " time(s)." 
		 << endl << endl;


}//END...Function greet_English

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
