/*	******************************************************************
	C++ Function OVERLOADING
	******************************************************************
	-	This program shows how to Overload functions
	-	i.e. Implement funtions with the SAME NAME
*/
#include <iostream>
using namespace std;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Function DECLARATIONS
//	-	Signatures are different
//
int calc_Tax( int, int );
double calc_Tax( double, int );

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int main()
{
	//
	// Function Invocations

	//================================================================
	double charge_IT_perHour = 250;
	int num_Hours_IT = 12;

	//	Compiler knows which one to call since there is ONE function 
	//	-	called calc_Tax which 
	//		-	takes in a double and an int in that order
	//		-	returns a double
	//
	double tax_IT = calc_Tax( charge_IT_perHour, num_Hours_IT );

	//================================================================
	int cost_Ticket_rugbyMatch = 55;
	int num_People_rugbyMatch = 22;

	//	Compiler knows which one to call since there is ONE function 
	//	-	called calc_Tax which 
	//		-	takes in two ints
	//		-	returns an int
	//
	int tax_rugbyMatch = calc_Tax(	cost_Ticket_rugbyMatch,
									num_People_rugbyMatch
								 );

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Overloading Functions" 
		 << " " 
		 << endl;
	while(true){} 
	return 0;

}//END...Function MAIN


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Function DEFINITIONS
//
int calc_Tax( int ticketPrice, int numPeople )
{
	int total_Price = ticketPrice * numPeople;
	int tax_Rate = 0.3;
	int tax_Amount = tax_Rate * total_Price;
	return ( tax_Amount );

}//END Function int calc_Tax( int, int )

double calc_Tax( double chargePerHour, int num_Hours )
{
	double total_Income = chargePerHour * static_cast<double>(num_Hours);
	double tax_Rate = 0.25;
	double tax_Amount = tax_Rate * total_Income;
	return ( tax_Amount );

}//END Function double calc_Tax( double, int )

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
