/*	******************************************************************
	C STYLE MACRO CONDITIONAL DEFINITIONS
	******************************************************************
	-	This program shows how to implement and use conditional 
		macro definitions 
	-	Avoid whenever possible in C++
*/
#include <iostream>
using namespace std;

#define NUM_PEOPLE 50
#define PRICE_PER_TICKET 5

// The #ifdef, #ifndef, #endif Clauses 
#ifndef PRICE_PER_TICKET
	#define PRICE_PER_TICKET 10
	#define HALL_CAPACITY 20000
#endif

#ifndef	HALL_CAPACITY
	#define NUM_SEATS 400
#endif

#ifndef NUM_COFFEE_ORDERS
	#define NUM_BEVERAGE_ORDERS 500
#endif

#ifdef PRICE_PER_TICKET
	#define PRICE_TICKET_CARNET 90
#endif
//

int main( )
{
	cout << "NUM_PEOPLE is " << NUM_PEOPLE << endl;
	cout << "PRICE_PER_TICKET is " << PRICE_PER_TICKET << endl;

	// Error: HALL_CAPACITY has not been macro-defined
	//	since PRICE_PER_TICKET has been defined
	// cout << "HALL_CAPACITY is " << HALL_CAPACITY << endl;

	// NUM_SEATS gets macro-defined since HALL_CAPACITY has not been
	// macro-defined
	cout << "NUM_SEATS is " << NUM_SEATS << endl;

	// PRICE_TICKET_CARNET gets macro-defined since PRICE_PER_TICKET
	// has been macro-defined
	cout << "PRICE_TICKET_CARNET is " << PRICE_TICKET_CARNET << endl;


	//
	cout << endl << endl << "===========" << endl 
		 << "END...Demo #ifdef, #ifndef, #endif Clauses" << endl;
	while(true){} 
    return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

