/*	******************************************************************
	C++ INLINE Functions
	******************************************************************
	-	This program shows how to implement and use
		Inline Functions
*/
#include <iostream>
using namespace std;

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Inline Function DECLARATION
//
inline int calc_double( int );

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int main()
{
	int my_Int_A = 7;

	cout << "my_Int_A = " << my_Int_A << endl;

	cout <<	"...doubled using calc_double(my_Int_A) = " 
		 << calc_double(my_Int_A) 
		 << endl;

	// Correct answer when combined with other mathematical operations
	// - problem with macros has been eliminated
	//
	cout <<	"...doubled then tripled using "
		 << " calc_double(my_Int_A) * 3 = " 
		 << calc_double(my_Int_A) * 3
		 << endl;

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Inline Functions" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Inline Function DEFINITION
//
inline int calc_double( int int_IN_A )
{
	return ( int_IN_A + int_IN_A );

}//END...Inline Function calc_double


//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

