/*	******************************************************************
	FIBONACCI SERIES using RECURSION
	******************************************************************
	-	This program implements the famous Fibonacci Sequence:
		Each term is the sum of the previous two
*/
#include <iostream>
#include <string>
using namespace std;

long int generate_Fibonacci_Number( int );

int main( )
{
	//
	cout << "=============================================" << endl 
		 << "Generating terms of the Fibonacci Sequence..." << endl
		 << "=============================================" << endl 
		 << endl;
	//
	//	Displaying the First 11 Fibonacci terms
	//
	for( int i = 0; i < 11; ++i )
	{
		cout << "fibonacci( " << i << " ) = " 
			<< generate_Fibonacci_Number (i) << endl;
	}

	//
	//	Displaying higher Fibonacci terms
	//
	cout << "fibonacci( 15 ) = " << generate_Fibonacci_Number( 15 )
		 << endl;
	cout << "fibonacci( 20 ) = " << generate_Fibonacci_Number( 20 )
		 << endl;
	cout << "fibonacci( 30 ) = " << generate_Fibonacci_Number( 30 )
		 << endl;
	cout << "fibonacci( 35 ) = " << generate_Fibonacci_Number( 35 )
		 << endl;
	cout << "fibonacci( 45 ) = " << generate_Fibonacci_Number( 45 )
		 << endl;

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Fibonacci Series using Recursion" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN


//	---------------------------------------------
//	Recursive Function DEFINITION
//	---------------------------------------------
/*	FUNCTION: generate_Fibonacci_Number
	-	Returns the term of the Fibonacci Sequence for that 
		particular index
	-	Input: Index
*/
long int generate_Fibonacci_Number( int myINT_IN )
{
	//
	if( ( myINT_IN == 0 ) || ( myINT_IN == 1 ) )
	{
		return myINT_IN;
	}
	//
	else
	{
		return( generate_Fibonacci_Number( myINT_IN - 1 ) + 
				generate_Fibonacci_Number( myINT_IN - 2 ) 
			  );
	}
}//END...generate_Fibonacci_Number

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

