/*	******************************************************************
	GENERATING PERMUTATIONS
	******************************************************************
	-	This program generates the 4! (=24) permutations of
		C A T S
	-	Uses the next_permutation functionality
		-	Found in the Standard Library
*/
#include <iostream>
#include <string>
#include <algorithm>    
using namespace std;

int main( )
{
	//
	cout << "====================" << endl 
		 << "STRING PERMUTATIONS"  << endl
		 << "====================" << endl 
		 << endl;

	char myStr_A[] = {'c', 'a', 't', 's'};
	int length_myStr_A = sizeof(myStr_A) / sizeof(char);
	cout << "length_myStr_A = " << length_myStr_A << endl;
	
	cout << "The 4! possible permutations of C A T S:" << endl ;
	do
	{
		cout << myStr_A[0] << ' ' 
			 << myStr_A[1] << ' ' 
			 << myStr_A[2] << ' ' 
			 << myStr_A[3] << ' ' 
			 << endl;
	}
	while ( next_permutation( myStr_A, myStr_A + length_myStr_A));
	
	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Next Permutation Algorithm" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

