/*	******************************************************************
	Hanoi Towers
	******************************************************************
	-	Demonstrates using Recursion for Hanoi Towers 
*/
#include <iostream>
#include <string>
using namespace std;

//====================================================================
void operate_HanoiTowers(	int ,char, char, char );

//====================================================================
int main( )
{
	//
	int num_Disks = 0;

	cout << "******* 3 Disks *******" << endl;
	num_Disks = 3;
	operate_HanoiTowers( num_Disks, 'A', 'B', 'C' );

	cout << endl << "******* 4 Disks *******" << endl;
	num_Disks = 4;
	operate_HanoiTowers( num_Disks, 'A', 'B', 'C' );

	cout << endl << "******* 6 Disks *******" << endl;
	num_Disks = 6;
	operate_HanoiTowers( num_Disks, 'A', 'B', 'C' );


	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Hanoi Towers" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//====================================================================
void operate_HanoiTowers(	int top,
							char tower_From,
							char tower_Intermediate,
							char tower_To
						)
{
	//
	if( top == 1 )	// Base Case: 1 Disk
	{
		cout << "Disk 1 from Tower " << tower_From 
			 << " to Tower " << tower_To 
			 << endl;
	}
	//
	else
	{
		// Move Sub Tower
		operate_HanoiTowers(	( top - 1 ),
								tower_Intermediate,
								tower_From,
								tower_To
							);
		cout << "Disk " << top 
			 << " from Tower " << tower_From 
			 << " to Tower " << tower_To 
			 << endl;

		// Operating the Sub Tower
		operate_HanoiTowers(	( top - 1 ),
								tower_Intermediate,
								tower_From,
								tower_To
							);
	}
}//END...Function operate_HanoiTowers

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
