/*	******************************************************************
	C++ POINTERS
	******************************************************************
	-	This program demonstrates
		-	Defining Pointers
		-	Populating Pointers
		-	Decoding Pointers
*/
#include <iostream>
using namespace std;


int main()
{
	// 
	int myInt_A = 5;
	double myDbl_B = 7.2;

	/* 
		DEFINING A POINTER
		-	The Asterisk operator * is used 
	*/
	int *ptrInt_myInt_A;	// Defining ptrInt_myInt_A as type 
							// Pointer-to-int using int *

	/* 
		POPULATING i.e. Initialising A POINTER
		-	The VALUE held in ptrInt_myInt_A will be 
			the hexadecimal ADDRESS of myInt_A
		-	The Ampersand & operator is used
	*/
	ptrInt_myInt_A = &myInt_A;	//	Take the hexadecimal address of 
								//	myInt_A
								//	-	Put it into ptrInt_myInt_A


	//================================================================
	// Better to define and populate on the same line:
	double *ptrDbl_myDbl_B = &myDbl_B;

	//================================================================
	//	At this stage, we can display the hexadecimal address
	//	- this is only sometimes needed7
	cout << "========= DISPLAYING ADDRESSES =========" << endl;
	cout << "Hexadecimal address of myInt_A: ptrInt_myInt_A = " 
		 << ptrInt_myInt_A 
		 << endl;
	cout << "Hexadecimal address of myDbl_B: ptrDbl_myDbl_B = " 
		 << ptrDbl_myDbl_B 
		 << endl;

	/* 
		DECODING THE CONTENTS OF A POINTER
		-	i.e. Extracting the value of 5, held in myInt_A, 
			using ptrInt_myInt_A
		-	The asterisk operator * is used again
	*/
	cout << endl << "========= DECODING POINTERS =========" << endl;
	cout << "Accessing via Pointers: " << endl;
	cout << "*ptrInt_myInt_A = " << *ptrInt_myInt_A << endl;
	cout << "*ptrDbl_myDbl_B = " << *ptrDbl_myDbl_B << endl;
	
	cout << endl << "Accessing directly: " << endl;
	cout << "myInt_A = " << myInt_A << endl;
	cout << "myDbl_B = " << myDbl_B << endl;

	//
	cout << endl << "===========" 
		 << endl << "END...C++ Pointers Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...function main

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
