/*	******************************************************************
	EQUATING POINTERS	
	******************************************************************
	-	This program shows how to make one pointer contain the value
		-	i.e. address of another variable
		-	of another pointer
*/
#include <iostream>
using namespace std;

int main( )
{
	//
	int myInt_A = 5, myInt_B = 17;
	int *ptr_Int_01 = &myInt_A;
	int *ptr_Int_02 = &myInt_B;

	cout << endl << "========= INITIALLY... =========" << endl;
	cout << "myInt_A = " << myInt_A << endl;
	cout << "myInt_B = " << myInt_B << endl;
	cout << " ptr_Int_01 points to = myInt_A, so *ptr_Int_01 = " 
		 << *ptr_Int_01 << endl;
	cout << " ptr_Int_02 points to = myInt_B, so *ptr_Int_02 = " 
		 << *ptr_Int_02 << endl;

	//
	cout << endl << "========= EQUATING... =========" << endl;
	ptr_Int_02 = ptr_Int_01;
	cout << "...saying ptr_Int_02 = ptr_Int_01" << endl;

	//
	cout << endl << "========= NEW SETTINGS... =========" << endl;
	cout << "myInt_A = " << myInt_A << endl;
	cout << "myInt_B = " << myInt_B << endl;
	cout << " ptr_Int_01 still points to = myInt_A, so" 
		 << " *ptr_Int_01 = " << *ptr_Int_01 << endl;
	cout << " ptr_Int_02 now also points to = myInt_A, so" 
		 << " *ptr_Int_02 = " << *ptr_Int_02 << endl;


	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Equating Pointers" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
