/*	******************************************************************
	VOID POINTER DEMO
	******************************************************************
	-	This program demonstrates how Void Pointers are implemented
		in C and C++
	-	aVOID Void Pointers whenever possible in C++
		-	Treat this as reference material
	-	Void Pointers can contain the address of any type of variable
		-	This usually means losing track of types
		-	In C++, where Polymorphism is widely supported, this is
			unacceptable
*/
#include <iostream>
using namespace std;

int main( )
{
	//
	double myDbl_A = 7.35;
	int myInt_A = 9;

	// A void pointer can point to different types
	void *ptrVoid_myDbl_A = &myDbl_A;
	void *ptrVoid_myInt_A = &myInt_A;

	//
	//	Cannot dereference void pointers directly...
	//	-	The following are illegal:
	/*
		cout << "The value of the pointee of ptrVoid_myDbl_A is " 
			 << *ptrVoid_myDbl_A << endl;

		 cout << "The value of the pointee of ptrVoid_myInt_A is " 
		 << *ptrVoid_myInt_A << endl;
	*/
	//
	// ...They need to be cast
	//
	cout << "The value of the pointee of ptrVoid_myDbl_A is " 
		 << *(static_cast<double*>(ptrVoid_myDbl_A)) 
		 << endl;

	cout << "The value of the pointee of ptrVoid_myInt_A is " 
		 << *(static_cast<int*>(ptrVoid_myInt_A)) 
		 << endl;

	//
	cout << endl << "===========" 
		 << endl << "END...C++ Void Pointers Demo" 
		 << endl;
	while(true){}
    return 0;

}//END...function main

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
