/*	******************************************************************
	MULTIPLE POINTER-POINTER HIERARCHIES
	******************************************************************
	-	This program shows how we can implement and use a 
		-	Pointer-to-Pointer-to-int
		-	Pointer-to-Pointer-to-double
*/
#include <iostream>
#include <string>
using namespace std;

int main( )
{
	//
	//	Implementing 
	//	-	Variables
	//	-	Pointers to them
	//	-	Pointers to these Pointers
	//
	int myInt_A = 7;
	double myDbl_B = 8.2;

	//================================================================
	//	Pointer-to-int, Pointer-to-double
	//
	int *ptrInt_myInt_A = &myInt_A;
	double *ptrDbl_myDbl_B = &myDbl_B;

	//================================================================
	//	Pointer-to-Pointer-to-int, Pointer-to-Pointer-to-double
	//
	int **ptrPtrInt_myInt_A = &ptrInt_myInt_A;
	double **ptrPtrDbl_myDbl_B = &ptrDbl_myDbl_B;

	//================================================================
	//	Pointer-to-Pointer-to-Pointer-to-int, 
	//	Pointer-to-Pointer-to-Pointer-to-double
	//
	int ***ptrPtrPtrInt_myInt_A = &ptrPtrInt_myInt_A;
	double ***ptrPtrPtrDbl_myDbl_B = &ptrPtrDbl_myDbl_B;

	//
	//	Decoding Pointers 
	//	
	cout << "myInt_A = " << myInt_A << endl;
	cout << "*ptrInt_myInt_A = " << *ptrInt_myInt_A << endl;
	cout << "**ptrPtrInt_myInt_A = " 
				<< **ptrPtrInt_myInt_A << endl;

	cout << "***ptrPtrPtrInt_myInt_A = " 
				<< ***ptrPtrPtrInt_myInt_A << endl;

	cout << endl;

	cout << "myDbl_B = " << myDbl_B << endl;
	cout << "*ptrDbl_myDbl_B = " << *ptrDbl_myDbl_B << endl;
	cout << "**ptrPtrDbl_myDbl_B = " 
				<< **ptrPtrDbl_myDbl_B << endl;

	cout << "***ptrPtrPtrDbl_myDbl_B = " 
				<< ***ptrPtrPtrDbl_myDbl_B << endl;

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Mulitple Pointer-Pointer Hierarchies" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
