/*	******************************************************************
	READ ONLY POINTERS WITH CONST
	******************************************************************
	-	This Program demonstrates how to assign READ-ONLY status, 
		using const, to
		-	The Pointer
		-	The Pointee (data being [pointed to)
		-	Both the Pointer and Pointee
	-	In the definition, look at where the const keyword is in 
		relation to the asterisk * operator and use BPTAP
		-	Before Pointer-To (i.e. pointee )
		-	After Pointer
*/
#include <iostream>
using namespace std;

int main( )
{
	//
	int myInt_A = 14, myInt_B = 17, myInt_C = 23, myInt_D = 27, 
		myInt_E = 35, myInt_F = 44, myInt_G = 53, myInt_H = 67;
	
	//
	int *ptrInt_myInt_A = &myInt_A;

	//
	// The const keyword is BEFORE the asterisk *
	//
	const int *ptrInt_myInt_B = &myInt_B;	
	// *ptrInt_myInt_B = 79;	// ILLEGAL - contents of ptrInt_myInt_B 
								// are read-only ( via the pointer )
	ptrInt_myInt_B = &myInt_F;	// OK - ptrInt_myInt_B is writeable

	myInt_B = 78;	// OK - "Outside" the pointer, 
					// myInt_B is still writeable

	//
	// The const keyword is AFTER the asterisk *
	//
	int * const ptrInt_myInt_C = &myInt_C;	
	// ptrInt_myInt_C = &myInt_G;	//	ILLEGAL - ptrInt_myInt_C 
									//	is read-only

	*ptrInt_myInt_C = 25;		//	OK - contents of ptrInt_myInt_C 
								//	are writeable

	//
	// The const keyword is both BEFORE and AFTER the asterisk *
	//
	const int * const ptrInt_myInt_D = &myInt_D;

	// ptrInt_myInt_D = &myInt_H;	// ILLEGAL - ptrInt_myInt_D 
									// is read-only

	// *ptrInt_myInt_D = 29;		//	ILLEGAL - contents of 
									//	ptrInt_myInt_D are read-only 
									//	( via the pointer )

	myInt_D = 30;	//	OK - "Outside" the pointer, myInt_D is still 
					//	writeable

	//
	cout << endl << endl << "===========" << endl 
		 << "END...C++ Demo Const with Pointers" << endl;
	while(true){} 
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
