/*	******************************************************************
	SWAP USING REFERENCES
	******************************************************************
	-	This program shows how a Funtion
		-	which swaps over 2 numbers
		-	can be implemented using Refernces as Inputs
			-	This is very similar to using Pointers as Inputs
*/
#include <iostream>
using namespace std;

void swap_usingReferences( int&, int&  );


int main()
{
	//
	int myInt_A = 11, myInt_B = 13;

	cout << "Before the attempted swap myInt_A = " << myInt_A  
		 << " and myInt_B = " << myInt_B 
		 << endl;
	
	//
	/*	INVOKING swap_usingReferences - inputs References
		-	Want the inputs to be 
			-	"The ADDRESS of myInt_A", 
			-	"The ADDRESS of myInt_B"
		-	We say myInt_A and myInt_B, since 
			-	the operator to say "The address of a variable 
				referred to by a reference": NOTHING
	*/
	swap_usingReferences( myInt_A, myInt_B  );	

	//
	cout << "After the attempted swap myInt_A = " << myInt_A  
		 << " and myInt_B = " << myInt_B 
		 << endl;

	//
	cout << endl << "===========" 
		 << endl << "END...C++ References as Function Inputs Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...function main


/*	==================================================================
	Function DEFINITION: swap_usingReferences
	-	We are now going to pass the variables themselves, 
		not their values
	-	When a variable is defined, (for the best part) it stays in the 
		SAME memory location until it goes out of scope
	-	Thus passing this memory ADDRESS to the function is the way we 
		ensure the variable itself is passed
		-	Here we achieve this using References
*/ 
void swap_usingReferences( int& ref_Int_In_A, int& ref_Int_In_B  )
{
	int temp = ref_Int_In_B;	//	temp = Value of the CONTENTS OF 
								//	ref_Int_In_B
	ref_Int_In_B = ref_Int_In_A;
	ref_Int_In_A = temp;

}// END...function swap_usingReferences


//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
