/*	******************************************************************
	READ ONLY REFERENCES WITH CONST
	******************************************************************
	-	This Program demonstrates how to assign READ-ONLY status, 
		using const, to
		-	The Referee (data being [pointed to)
		-	The Reference is Read-Only anyway
			-	adding const 
				-	does not is redundant
	-	Again, in the definition, look at where the const keyword is in 
		relation to the ampersand & operator and use BPTAP
		-	Before Pointer-To (i.e. pointee )
		-	After Pointer
*/
#include <iostream>
using namespace std;

int main( )
{
	//
	int myInt_A = 14, myInt_B = 17, myInt_C = 23, myInt_D = 27, 
		myInt_E = 35, myInt_F = 44, myInt_G = 53, myInt_H = 67;
	
	//
	int &refInt_myInt_A = myInt_A;

	//
	// The const keyword is BEFORE the ampersand &
	//	-	Contents of the Reference are Read-only
	//
	const int &refInt_myInt_B = myInt_B;	
//	refInt_myInt_B = 79;	// ILLEGAL - contents of refInt_myInt_B 
							// are read-only ( via the reference )

	myInt_B = 78;	// OK - "Outside" the reference, 
					// myInt_B is still writeable

	//
	//	The const keyword is AFTER the ampersand & - REDUNDANT
	//	-	The Reference is Read-only
	//		-	It is anyway, so this is redundant!
	//
	int& const refInt_myInt_C = myInt_C;	

	refInt_myInt_C = 25;		//	OK - contents of refInt_myInt_C 
								//	are writeable

	//
	// The const keyword is both BEFORE and AFTER the ampersand &
	//
	const int & const refInt_myInt_D = myInt_D;

//	refInt_myInt_D = myInt_H;	// ILLEGAL - refInt_myInt_D 
								// is read-only

//	refInt_myInt_D = 29;		//	ILLEGAL - contents of 
								//	refInt_myInt_D are read-only 
								//	( via the pointer )

	myInt_D = 30;	//	OK - "Outside" the pointer, myInt_D is  
					//	still writeable

	//
	cout << endl << endl << "===========" << endl 
		 << "END...C++ Demo: Const with References" << endl;
	while(true){} 
	return 0;
	int *ptr_Int_A = new int(0);

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
