/*	******************************************************************
	C++: "CONTENTS OF" OPERATOR, "&", ON ARRAYS AND POINTERS
	******************************************************************
*/

#include <iostream>
#include <string>
using namespace std;

int main()
{
	//
	int myInt_A = 5;
	int *ptrInt_myInt_A = &myInt_A;
	int myArrInt_A[] = { 4, 34, 23, 86, 23, 7 };

	//
	//	OPERANDS TO "CONTENTS OF" & OPERATOR
	//

	// ptr_ptrInt_myInt_A is a Pointer-to-Pointer-to-Int
	int **ptr_ptrInt_myInt_A = &ptrInt_myInt_A;
	
	cout << "The contents of the contents of ptr_ptrInt_myInt_A: " 
		 << **ptr_ptrInt_myInt_A
		 << endl;
	cout << "...i.e. an integer" 
		 << endl << endl;
	
	// ptr_myArrInt_A is a pointer to an ENTIRE array of ints
	int (*ptr_myArrInt_A)[6] = &myArrInt_A;

	cout << "The contents of the contents of ptr_myArrInt_A: " 
		 << **ptr_myArrInt_A
		 << endl;
	cout << "...i.e. the 1st element of an array of integers" 
		 << endl;

	//
	cout << endl << endl << "=======================" 
		 << endl 
		 << "END...Demo, Using Contents of Operator & " 
		 << "on Arrays and Pointers." 
		 << endl;
	while(true){} 
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
