/*	******************************************************************
	C++: SCOPE/OUT OF SCOPE
	******************************************************************
	-	Demo only, don't try to build and run this
*/
#include <iostream>
#include <string>
using namespace std;

// Global Function
int myFunc( int myInt_IN );

// Global Variable
int myGlobalInt = 8;	// AVOID global variables

int main()	// Variable myGlobalInt comes into scope, placed on runtime stack
{
	

	int myMainInt = 7;	// Variable myMainInt comes into scope, placed on runtime stack

	int myresult = myFunc( myMainInt );	// Variable myresult comes into scope, placed on runtime stack
										// Program now jumps to the function myFunc

	return 0;

}// End of main() - myresult, myMainInt go OUT OF SCOPE - discarded from the runtime stack

// End of Program: myLocalStaticInt, myGlobalInt go OUT OF SCOPE - discarded from the runtime stack

// Function Definition
int myFunc( int myInt_IN )	// Variable myMainInt comes into scope, placed on runtime stack
{
	int myLocalInt = 7;		// Variable myLocalInt comes into scope, placed on runtime stack
	static int myLocalStaticInt = 16;	// Variable myLocalStaticInt comes into scope, placed on runtime stack

	for( int i = 0; i < 10; ++i  )	// Variable i comes into scope, placed on runtime stack
	{
		int myForInt = 19;			//	Variable myForInt comes into scope, placed on runtime stack

		if( myForInt == 10 )
		{
			// Conditional actions
			double myIfInt = 9;		//	Variable myIfInt comes into scope, placed on runtime stack

		}// END...if statement...myIfInt goes OUT OF SCOPE - discarded from the runtime stack

		// myIfInt = 9;		// ERROR: myIfInt has gone OUT OF SCOPE - i.e. nolonger exists
	
	}// END...for loop...myForInt and i go OUT OF SCOPE - discarded from the runtime stack

	return myLocalInt;

}// END...function myFunc...myLocalInt and myInt_IN go OUT OF SCOPE - discarded from the runtime stack
					// NB. myLocalStaticInt stays in scope for the duration of the program
					//		-	that's why it can retain its value between function calls

// Jump back to the part of the program after the function call

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 

