/*	******************************************************************
	C++: USING THE STACK AND HEAP RUNTIME MEMORY
	******************************************************************
	SIMPLE TASK: Adding 2 numbers
	No less than 4 different ways to do this
	(1)	Using the runtime STACK
		(1.1)	Accessing directly
		(1.2)	Accessing using Pointers
		(1.3)	Accessing using References
	(2)	Using the runtime HEAP
		(2.1)	Accessing using Pointers
*/
#include <iostream>
#include <string>

using namespace std;

int main()
{
	//
	//	(1)	Using the runtime STACK
	//		(1.1)	Accessing directly
	cout << endl << "=======" << endl << "Using the Runtime Stack, "
									  << "accessing Directly" 
		 << endl;
	int myInt_1_1_A = 5, myInt_1_1_B = 6, myInt_1_1_C = 0;
	myInt_1_1_C = myInt_1_1_A + myInt_1_1_B;
	cout << "The total of " << myInt_1_1_A << " and " << myInt_1_1_B 
		 << " is " << myInt_1_1_C << endl;

	//------------------------------------------------
	//		(1.2)	Accessing using Pointers
	cout << endl << "=======" << endl << "Using the Runtime Stack, "
										 "accessing using Pointers" 
		 << endl;
	int myInt_1_2_A = 7, myInt_1_2_B = 8, myInt_1_2_C;
	
	int *ptr_myInt_1_2_A = &myInt_1_2_A;
	int *ptr_myInt_1_2_B = &myInt_1_2_B;
	int *ptr_myInt_1_2_C = &myInt_1_2_C;

	*ptr_myInt_1_2_C = *ptr_myInt_1_2_A + *ptr_myInt_1_2_B;
	cout << "The total of " << *ptr_myInt_1_2_A << " and " 
							<< *ptr_myInt_1_2_B << " is " 
							<< *ptr_myInt_1_2_C 
		 << endl;
	
	//------------------------------------------------
	//		(1.3)	Accessing using References
	cout << endl << "=======" << endl << "Using the Runtime Stack, "
									  << "accessing using References" 
		 << endl;
	int myInt_1_3_A = 9, myInt_1_3_B = 10, myInt_1_3_C;
	
	int& ref_myInt_1_3_A = myInt_1_3_A;
	int& ref_myInt_1_3_B = myInt_1_3_B;
	int& ref_myInt_1_3_C = myInt_1_3_C;

	ref_myInt_1_3_C = ref_myInt_1_3_A + ref_myInt_1_3_B;

	cout << "The total of " << ref_myInt_1_3_A << " and " 
							<< ref_myInt_1_3_B << " is " 
							<< ref_myInt_1_3_C 
		 << endl;

	//
	//	(2)	Using the runtime HEAP
	//		-	Accessing using Pointers
	cout << endl << "=======" << endl << "Using the Runtime Heap, "
									  << "accessing using Pointers" 
		 << endl;
	int *ptr_myInt_2_1_A = new int;	
	int *ptr_myInt_2_1_B = new int;
	int *ptr_myInt_2_1_C = new int;

	*ptr_myInt_2_1_A = 11;
	*ptr_myInt_2_1_B = 12;

	*ptr_myInt_2_1_C = *ptr_myInt_2_1_A + *ptr_myInt_2_1_B;

	cout << "The total of " << *ptr_myInt_2_1_A << " and " 
							<< *ptr_myInt_2_1_B << " is " 
							<< *ptr_myInt_2_1_C 
		 << endl;

	// Do not forget to discard these!!!
	delete ptr_myInt_2_1_A;
	delete ptr_myInt_2_1_B;
	delete ptr_myInt_2_1_C;
	
	ptr_myInt_2_1_A = NULL;
	ptr_myInt_2_1_B = NULL;
	ptr_myInt_2_1_C = NULL;

	//
	cout << endl << "=========" 
		 << endl << "End...C++ Demo: Adding numbers using "
				 << "the Runtime Stack And Heap Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
