/*	******************************************************************
	FUNCTION USING THE RUNTIME HEAP	
	******************************************************************
	-	Function places data on the Heap Runtime Memory
		-	Calculates Total Ticket price
		-	Returns a Pointer to this
	-	This Pointer is then used by function calling it
		-	In this case main
*/
#include <iostream>
#include <string>
using namespace std;

//====================================================================
double* calc_TotalCost( int numTickets, double pricePerTicket );

//====================================================================
int main( )
{
	//
	int num_London2012_CyclingTickets = 23;
	double cost_London2012_Ticket_Cycling = 75.0;

	double *ptr_Cost_Cycling 
		= calc_TotalCost(	num_London2012_CyclingTickets, 
							cost_London2012_Ticket_Cycling 
						);

	cout << "The cost of taking " 
		 << num_London2012_CyclingTickets << " people, "
		 << "each ticket costing " << cost_London2012_Ticket_Cycling
		 << " will be " << *ptr_Cost_Cycling
		 << endl;

	// Do not forget to free up the Heap Memory
	delete ptr_Cost_Cycling;
	ptr_Cost_Cycling = NULL;


	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Function using the Runtime Heap" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

/*	====================================================================
	FUNCTION:	calc_TotalCost
	-	Calculates total ticket price
		-	Inputs: Number of Tickets, Price per Ticket
		-	Places the result on the heap
			-	Returns a Pointer to it
*/
double* calc_TotalCost( int numTickets, double pricePerTicket )
{
	double *ptr_totalCost = new double(0.0);

	*ptr_totalCost = static_cast<double>(numTickets) * pricePerTicket;

	return ptr_totalCost;

}//END...Function calc_TotalCost

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 


