/*	******************************************************************
	HEAP MEMORY LEAK
	******************************************************************
	-	Demonstrates Memory Leaks
		-	Simply reallocation of a Pointer to a Heap
			-	Lost all access to this part of the Heap
	-	Leaky Loop
		-	Reallocates the same pointer to different parts of the
			Heap per iteration
			-	Each  iteration - it loses the pointer it allocated
				on the last iteration
*/
#include <iostream>
#include <string>
using namespace std;

int main( )
{
	//
	int myInt_Stack_A = 7;

	// Creating an int on the Heap, accessing it using a Pointer
	int *ptr_myInt_Heap_A = new int(13);

	// POTENTIAL DISASTER: Reallocating the Pointer to a Stack 
	// Variable
	ptr_myInt_Heap_A = &myInt_Stack_A;

	// ===== MEMORY LEAK! ===== All access to the integer on the 
	// Heap has now been lost!

	//
	//	LEAKY LOOP!
	//	-	Each iteration - it loses the pointer it allocated
	//		on the last iteration!
	//
	for( int i = 0; i < 7; ++i )
	{
		double *ptr_Dbl = new double(i);
	}


	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Heap Memory Leak" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
