/*	******************************************************************
	REFERENCE TO STRUCT
	******************************************************************
	-     Defining the ADT Struct
	-     Instantiating and Using Structs
	-     Defining a Reference-to-Struct,
		-     using it to access individual Data Members
*/
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

int main( )
{
	//
	//	Defining instance joeBloggs and populating Data Members
	//
	Employee joeBloggs;

	//
	//	Reference to Struct
	//
	Employee &ref_joeBloggs = joeBloggs;

	//================================================================
	//	Accessing Data Members using the . Operator
	//
	ref_joeBloggs.name = "Joseph Bloggs";
	ref_joeBloggs.salary_Gross = 20000.0;
	ref_joeBloggs.taxRate = 0.3;
	cout  << "The Gross Salary of Joseph Bloggs is "
		  << ref_joeBloggs.salary_Gross
		  << endl;	
	
	// ...Further population via the Reference

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: References to Struct" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
