/*	******************************************************************
	CLASSES & OBJECTS IN C++
	******************************************************************
	-	This program demonstrates Abstraction & Encapsulation in C++
		through
		-	The implementation of
			-	A Class
			-	Objects based on this Class
		-	Usage of the Dot Operator
		-	Effects of the Access Specifiers Private & Public
*/
#include <iostream>
#include <string>
using namespace std;

// METHOD (1)	Declaring and Defining a Class in One
class Employee
{
	private:
		// Data Member(s)
		string name;
		string nI_Number;
		double salary_Gross;
		double tax_Rate;
		double tax_Amount;
		double salary_Net;

	public:
		// Member Function(s)
		void greet()
		{
			cout << "Hello, I'm an Employee" << endl;
		}
};// END...class Employee


int main()
{
	// Creating an OBJECT joeBloggs
	Employee joeBloggs;

	//	Accessing the members of the object...
	//	DIRECTLY via the Object - use .DOT Operator
	joeBloggs.greet(); //	OK - greet() is PUBLIC			
	
	// joeBloggs.name = "Joseph Bloggs"; // ILLEGAL - name is PRIVATE

	//
	cout << endl << "===============" 
		 << endl << "END...C++ Class & Object Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

