/*	******************************************************************
	ARRAY OF OBJECTS IN C++
	******************************************************************
	-	This program demonstrates the Implementaion and Usage of an
		Array of Objects in C++

	-	NOTE: This is for Reference
		-	Arrays are NOT the optimal C++ container for Objects
		-	STL Containers, such as Vectors and Deques are far
			more suitable
			-	Covered in Cybernetics in C++ - Expert
*/
#include <iostream>
#include <string>
using namespace std;

//
// METHOD (1)	Declaring and Defining a Class in One
class Employee
{
	private:
		// Data Member(s)
		string name;
		string nI_Number;
		double salary_Gross;
		double tax_Rate;
		double tax_Amount;
		double salary_Net;

	public:
		// Member Function(s)
		void greet()
		{
			cout << "Hello, I'm an Employee" << endl;
		}
};// END...class Employee

//
int main()
{
	//================================================================
	// Creating OBJECTS
	Employee joeBloggs;
	Employee johnSmith;
	Employee amandaTaylor;

	//================================================================
	// Creating an Array of Objects
	Employee office[] = { joeBloggs, johnSmith, amandaTaylor };
	for( int i = 0; i < 3; ++i ) // Better to use STL Iterators
								 // (C++ Part 2)
	{
		office[i].greet();
	}

	//================================================================
	cout << endl << "===============" 
		 << endl << "END...C++ Array of Objects Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

