/*	******************************************************************
	C++ OBJECTS ON THE HEAP	
	******************************************************************
	-	This Program demonstrates the implementation of Objects
		on the Runtime Heap
	-	Now: The Same Class, Employee, is bound to at
		-	Compile Time
		-	Runtime
	-	They can be Different
		-	This is OOP Polymorphism 
*/
#include <iostream>
#include <string>
using namespace std;

//
// METHOD (1)	Declaring and Defining a Class in One
class Employee
{
	private:
		// Data Member(s)
		string name;
		string nI_Number;
		double salary_Gross;
		double tax_Rate;
		double tax_Amount;
		double salary_Net;

	public:
		// Member Function(s)
		void greet()
		{
			cout << "Hello, I'm an Employee" << endl;
		}
};// END...class Employee


//
int main()
{
	//================================================================
	// Creating an OBJECT peterShepherd on the HEAP
	//	Creating & using a POINTER
	//
	Employee *ptr_peterShepherd = new Employee;

	ptr_peterShepherd -> greet();

	//	ILLEGAL - nI_Number is PRIVATE
	// ptr_peterShepherd ->nI_Number = "FG 34 56 93 D"

	delete ptr_peterShepherd;
	ptr_peterShepherd = NULL;

	//================================================================
	cout << endl << "===============" << endl 
		 << "END...C++ Objects on the Runtime HeapDemo" 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

