/*	******************************************************************
	DESTRUCTORS - RUNTIME STACK
	******************************************************************
	-	This program demonstrates the calling of Destructors for
		Objects on the Runtime Stack
		-	Two Functions are created, each with Employee Objects
		-	As the Functions are exited, the Objects go out of
			Scope
			-	In the REVERSE Order in which they were created
			-	Destructors are called when this happens
*/
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

void createOffice_01();
void createOffice_02();

int main( )
{
	//
	createOffice_01();
	createOffice_02();

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Destructors - Runtime Stack" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void createOffice_01()
{
	Employee joeBloggs( "Joseph Bloggs" );
	joeBloggs.greet_Name();

	Employee johnSmith( "John Smith", "GH 67 34 67 D" );
	johnSmith.greet_Name();

	Employee amandaTaylor( "Amanda Taylor", "SG 36 78 24 F", 22000.0 );
	amandaTaylor.greet_Name();

}//END...Function createOffice_01

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void createOffice_02()
{
	Employee sheilaHemingway( "Sheila Hemingway" );
	sheilaHemingway.greet_Name();

	Employee seanODriscoll( "Sean O'Driscoll" );
	seanODriscoll.greet_Name();

}//END...Function createOffice_02

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
