/*	******************************************************************
	DESTRUCTORS - RUNTIME HEAP
	******************************************************************
	-	Creating and Deleting Objects on the Runtime Heap
		-	new is used for the Creation
			-	This calls the appropriate CONSTRUCTOR
		-	delete is used for the Destruction
			-	This calls the DESTRUCTOR
*/
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

int main( )
{
	//
	// Creating OBJECTS on the runtime HEAP
	//
	Employee *ptr_scottHamilton = new Employee(	"Scott Hamilton", 
												"FG 45 90 87 D", 
												19750.0 );
	ptr_scottHamilton -> greet_AllAttributes();

	Employee *ptr_susanFletcher = new Employee(	"Susan Fletcher", 
												"EG 34 98 67 C", 
												21750.0 );
	ptr_susanFletcher -> greet_AllAttributes();

	Employee *ptr_patriciaCooper = new Employee("Patricia Cooper", 
												"SD 45 78 63 P", 
												23500.0 );
	ptr_patriciaCooper -> greet_AllAttributes();


	//
	// Deleting OBJECTS from the runtime HEAP
	//
	delete ptr_susanFletcher;
	ptr_susanFletcher = NULL;

	delete ptr_scottHamilton;
	ptr_susanFletcher = NULL;

	delete ptr_patriciaCooper;
	ptr_susanFletcher = NULL;

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: Constructor & Destructors invocations " 
		 << "on the Runtime Heap " 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
