/*	******************************************************************
	C++ ASSIGNMENT OPERATOR	
	******************************************************************
	-	Demonstrates the Usage of the ASSIGNMENT Operator
		-	Used in Object Oriented Programming
		-	To equate 2 EXISTING Objects
			-	i.e. Copy the Attributes 
				-	Data Member Values
				of one into another
		-	Note: They must both already be EXISTING
			-	One Cannot be created this way
*/
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

int main( )
{
	//
	//	Creating 2 Objects
	//	-	The Attributes of the Former
	//	-	Will be Copied into the Latter
	//
	Employee joeBloggs( "Joseph Bloggs", 
						"PH 45 67 34 D", 
						17000.0 );
							
	Employee joeAndrewBloggs(	"Joseph Andrew Bloggs", 
								"FG 45 23 78 G", 
								17000.0);

	//
	//	EQUATING 2 EXISTING Objects
	//	-	Assignment Operator is called now
	//
	joeAndrewBloggs = joeBloggs;

	cout << "=================================" << endl
		 << "Object: joeBloggs"; 
	joeBloggs.greet_AllAttributes();

	cout << "=================================" << endl
		 << "Object: joeAndrewBloggs"; 
	joeAndrewBloggs.greet_AllAttributes();

	//
	cout << endl << endl << "===========" 
		 << endl 
		 << "END...C++ Demo: C++ Assignment Operator" 
		 << " " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

