
#include "Employee.h"

// ---------- STATIC Data Member(s) ------------
int Employee::num_Employees = 0;


// ---------- CONSTRUCTORS ------------
Employee::Employee( string name_IN )
{
	name = name_IN;

	++num_Employees;

}


Employee::Employee( string name_IN, string nI_Number_IN )
{
	name = name_IN;
	nI_Number = nI_Number_IN;

	++num_Employees;

}

Employee::Employee( string name_IN, string nI_Number_IN, double salary_Gross_IN )
{
	name = name_IN;
	nI_Number = nI_Number_IN;
	salary_Gross = salary_Gross_IN;

	++num_Employees;
}


// ------- COPY Constructor ---------
Employee::Employee( Employee& ref_Employee_IN )
{
	name = ref_Employee_IN.name;
	nI_Number = ref_Employee_IN.nI_Number;
	salary_Gross = ref_Employee_IN.salary_Gross;
	tax_Rate = ref_Employee_IN.tax_Rate;
	tax_Amount = ref_Employee_IN.tax_Amount;
	salary_Net = ref_Employee_IN.salary_Net;

	cout << "Copy Constructor called for " << name << endl;
	
}// END...COPY Constructor




// ---------- DESTRUCTOR ------------
Employee::~Employee(  )
{
	cout << "Goodbye, I, " << name << " am  going out of scope now." << endl;

}//END...Destructor


// ---------- MUTATORS ------------
double Employee::get_salary_Gross(  ) const
{
	//	name  = "Peter Drury";	// ILLEGAL: The const keyword after the prototype ensures this
								//			member function cannot write data to any data member

	//	The const is useful for future proofing your program: nobody can add spurious code in 
	//	future which causes bugs
	//	i.e. ensures this member function only ever reads data members

	return salary_Gross;
}


void Employee::set_salary_Gross( double salary_Gross_IN )
{
	salary_Gross = salary_Gross_IN;
}

// ---------- STATIC MEMBER FUNCTION(S) ------------
// ...also a Mutator
int Employee::get_num_Employees()
{
	return num_Employees;
}

// ---------- "NORMAL Member Functions " ------------
void Employee::greet()	
{
	cout << "Hello, I'm an Employee" << endl;

}//END...Member Function greet

void Employee::greet_Name()	
{
	cout << "Hello, I'm an Employee, " 
		 << "my name is " << name 
		 << endl;

}//END...Member Function greet_Name

void Employee::greet_Name_NINumber()
{
	cout << "Hello, I'm an Employee, " 
		 << "my name is " << name 
		 << " and my NI Number is " << nI_Number
		 << endl;

}//END...Member Function greet_Name_NINumber


void Employee::greet_Name_SalaryGross()
{
	cout << "Hello, I'm an Employee, my name is " << name
		 << ", my Gross Salary is " << salary_Gross
		 << endl;

}//END...Member Function greet_Name_SalaryGross()


void Employee::greet_AllAttributes()
{
	cout << endl
		 << "=====================" 
		 << endl
		 << "Hello, I am an employee, my name is " << name << ", " 
		 << endl 
		 << "my NI Number is " << nI_Number << "," 
		 << endl
		 << "my Gross Salary is " << salary_Gross 
		 << endl
		 << "my tax Rate is " << tax_Rate << "%" 
		 << endl
		 << "so the amount I have to pay in tax is " << tax_Amount 
		 << endl
		 << "thus my Net Salary is " << salary_Net 
		 << endl
		 << "=====================" << endl;
}// END...MF greet_AllAttributes()


//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

