/*	******************************************************************
	C++ FRIEND FUNCTIONS 
	******************************************************************
*/
#include <iostream>
#include <string>
using namespace std;

#include "Patient.h"

bool check_IsBloodPressure_OK( Patient myPatient_IN );


int main()
{

	//
	Patient abigailMitchellmore( "Abigail Mitchellmore", 115 );
	Patient jonathanOLeary( "Jonathan O'Leary", 90 );
	Patient fredJohnson( "Fred Johnson", 125 );

	//
	check_IsBloodPressure_OK( abigailMitchellmore );
	check_IsBloodPressure_OK( jonathanOLeary );
	check_IsBloodPressure_OK( fredJohnson );

	//
	cout << endl << "===============" << endl 
		 << "END...C++ Demo: Friend Functions " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

/*	Function check_IsBloodPressure_OK
	-	Friend of Class Patient
*/
bool check_IsBloodPressure_OK( Patient myPatient_IN )
{
	
	if( ( myPatient_IN.bloodPressure > 95 ) && 
		( myPatient_IN.bloodPressure < 120 )
	  )
	{
		cout << endl << "The Blood Pressure of " 
			 << myPatient_IN.name << " is OK" 
			 << endl;
		return true;
	}

	cout << endl << "The Blood Pressure of " 
		 << myPatient_IN.name << " is not OK" 
		 << endl;
	return false;

}//END...Function check_IsBloodPressure_OK

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
