
#include "Employee.h"

// ---------- STATIC Data Member(s) ------------
int Employee::num_Employees = 0;


// ---------- CONSTRUCTORS ------------
Employee::Employee( string name_IN )
{
	name = name_IN;

	++num_Employees;
}//END...Constructor Employee( string )


Employee::Employee( string name_IN, string nI_Number_IN )
{
	name = name_IN;
	nI_Number = nI_Number_IN;

	++num_Employees;

}//END...Constructor Employee( string, string )

Employee::Employee( string name_IN, 
					string nI_Number_IN, 
					double salary_Gross_IN )
{
	name = name_IN;
	nI_Number = nI_Number_IN;
	salary_Gross = salary_Gross_IN;

	++num_Employees;

}//END...Constructor Employee( string, string, double )

// ---------- DESTRUCTOR ------------
Employee::~Employee(  )
{
	cout << "Goodbye, I, " << name 
		 << " am going out of scope now." 
		 << endl;

}//END...Destructor ~Employee( )


// ---------- MUTATORS ------------
double Employee::get_salary_Gross(  ) const
{
	return salary_Gross;

}//END...Mutator get_salary_Gross( )


void Employee::set_salary_Gross( double salary_Gross_IN )
{
	salary_Gross = salary_Gross_IN;

}//END...Mutator set_salary_Gross( )



// ---------- STATIC MEMBER FUNCTION(S) ------------
// ...also a Mutator
int Employee::get_num_Employees()
{
	return num_Employees;

}//END...Static Mutator get_num_Employees( )


// Member Function DEFINITIONS:
void Employee::greet()	// :: SCOPE RESOLUTION OPERATOR
{
	cout << endl
		 << "Hello, I'm an Employee" << endl;

}//END...Member Function greet( )


void Employee::greet_Name()
{
	cout << endl
		 << "Hello, I'm an Employee, my name is " << name
		 << endl;

}//END...Member Function greet_Name( )

void Employee::greet_Name_SalaryGross()
{
	cout << endl
		 << "Hello, I'm an Employee, my name is " << name
		 << ", my Gross Salary is " << get_salary_Gross()
		 << endl;

}//END...Member Function greet_Name_SalaryGross( )

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
