/*	******************************************************************
	C++ OPERATOR OVERLOADING: UNARY OPERATORS
	******************************************************************
*/
#include <iostream>
#include <string>
using namespace std;

class Counter
{
	private:
		unsigned int count;

	public:
		Counter() : count( 0 ){}
		Counter( int cin ) : count( cin ){}

		unsigned int get_count()
		{ 
			return count;
		}

		// PRE Increment
		Counter operator ++()
		{
			return ( Counter( ++count ) );
		}

		// POST Increment - keyword int
		Counter operator ++( int )
		{
			return ( Counter( count++ ) );
		}
};//END...Class Counter


int main()
{
	Counter c1, c2;

	cout << endl << "c1 = " << c1.get_count();
	cout << endl << "c2 = " << c2.get_count();

	++c1;
	c2 = ++c1;
	cout << endl << "c1 = " << c1.get_count();
	cout << endl << "c2 = " << c2.get_count();

	c2 = c1++;
	cout << endl << "c1 = " << c1.get_count();
	cout << endl << "c2 = " << c2.get_count();

	//
	cout << endl << "===============" << endl 
		 << "END...C++ Demo: Overloading Increment Operators " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
