/*	******************************************************************
	INHERITANCE IN C++: SINGLE, INTERFACE
	******************************************************************
*/
#include <iostream>
#include <string>
using namespace std;

/*	ABSTRACT (INTERFACE) CLASS:	
	-	All of the member functions have no body
*/
class Bear
{
	protected:
		string name;

	public:
		void greet()
		{
		}

		void greet_withName()
		{
		}
};//END...Abstract Class Bear


class BlackBear : public Bear
{
/*
	private:
		string name;
*/
	public:
		BlackBear( string name_In )
		{
			name = name_In;
		}

		void greet()
		{
			cout << "Hello, I'm a Black Bear" << endl;
		}

		void greet_withName()
		{
			cout << "Hello, I'm a Black Bear and my name is " 
				 << name << endl;
		}
};//END...Class BlackBear

class SlothBear : public Bear
{
//	private:
//		string name;

	public:
		SlothBear( string name_In )
		{
			name = name_In;
		}

		void greet()
		{
			cout << "Hello, I'm a Sloth Bear" << endl;
		}

		void greet_withName()
		{
			cout << "Hello, I'm a Sloth Bear and my name is " 
				 << name << endl;
		}
};//END...Class SlothBear

int main()
{
	//
	BlackBear gentleBen( "Gentle Ben" );	
	gentleBen.greet_withName();


	SlothBear baloo( "Baloo" );
	baloo.greet_withName();

	//
	cout << endl << "===============" << endl 
		 << "END...C++ Demo: Interface Single Inheritance " 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
