/*	******************************************************************
	INHERITANCE IN C++: MULTIPLE, IMPLEMENTATION - Ambiguities
	******************************************************************
*/
#include <iostream>
#include <string>
using namespace std;

#include "Lion.h"
#include "Tiger.h"
#include "Liger.h"


int main()
{
	//
	cout << endl
		 << "============" << endl 
		 << "Object creation: Liger, hercules"
		 << endl;
	Liger hercules;

	// hercules.greet(); 
		// ERROR: error C2385: ambiguous access of 'greet'

	// Resolving the Ambiguity
	hercules.Lion::greet();
	hercules.Tiger::greet();

	//
	cout << endl << "===============" << endl 
		 << "END...C++ Demo: Multiple Implementation Inheritance" 
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
