/*	******************************************************************
	PRIVATE, PROTECTED & PUBLIC INHERITANCE
	******************************************************************
*/
#include <iostream>
using namespace std;

//####################################################################
class Bear 
{
	private:
		int private_Data_Bear;
	protected:
		int protected_Data_Bear;
	public:
		int public_Data_Bear;

		void greet()
		{
			private_Data_Bear = 6;		// All OK, in same class
			protected_Data_Bear = 7;	//
			public_Data_Bear = 8;		//

		}//end...MF greet

};//END...CLASS Bear

//####################################################################
/*	PUBLIC INHERITANCE
	Public and Protected members of Bear are unchanged here
*/
class SlothBear : public Bear
{

	public:
		void greet_SlothBear()
		{
			// private_Data_Bear = 8;	
				//	ILLEGAL - cannot access private data in 
				//	Inherited classes

			protected_Data_Bear = 9;
				//	OK, can access protected data of Base Classes 
			
			public_Data_Bear = 10;		
				//	OK, can access public data of Base Classes 

		}//END...MF greet_SlothBear

};//END...CLASS SlothBear

//####################################################################
/*	PROTECTED INHERITANCE
	Public and Protected members of Bear are Protected members here
*/
class PetBear : protected Bear
{
	public:
		void greet_PetBear()
		{
			// private_Data_Bear = 8;	
				//	ILLEGAL - cannot access private data in 
				//	Inherited classes

			protected_Data_Bear = 9;	
				//	OK, can access protected data of Base Classes 
				//	-	It is Protected here
			
			public_Data_Bear = 10;		
				//	OK, can access public data of Base Classes
				//	-	It is Protected here

		}//END...MF greet_SlothBear

};//END...CLASS PetBear

//####################################################################
/*	PUBLIC i.e. PROTECTED then PUBLIC INHERITANCE
	Public and Protected members of Bear are Protected members here
*/
class TeddyBear : public PetBear
{
	public:
		void greet_TeddyBear()
		{
			// private_Data_Bear = 8;	
				//	ILLEGAL - cannot access private data in 
				//	Inherited classes
			
			protected_Data_Bear = 9;
				//	OK, can access protected data of Base Class
				//	-	Protected data of PetBear 
			
			public_Data_Bear = 10;		
				//	OK, can access public data of Base Class
				//	-	Protected data of PetBear 

		}//END...MF greet_SlothBear

};//END...CLASS TeddyBear

//####################################################################
/*	PRIVATE INHERITANCE
	Public and Protected members of Bear are Private members here
*/
class Panda : private Bear
{
		void greet_Panda()
		{
			// private_Data_Bear = 8;	
				//	ILLEGAL - cannot access private data in 
				//	Inherited classes
			
			protected_Data_Bear = 9;	
				//	OK, can access protected data of Base Classes 
			
			public_Data_Bear = 10;		
				//	OK, can access private data of Base Classes 

		}//END...MF greet_Panda

};//END...CLASS Panda


int main()
{
	//
	Bear winnieThePooh;
	// winnieThePooh.private_Data_Bear = 9;			
		// ILLEGAL: cannot access private data in Bear
	
	// winnieThePooh.protected_Data_Bear = 10;		
		// ILLEGAL: cannot access protected data in Bear
	
	winnieThePooh.public_Data_Bear = 5;
		// OK but inadvisable

	//
	//	PUBLIC INHERITANCE: 
	//	Protected and Public data members of Bear are unchanged
	//
	SlothBear baloo;

	// baloo.private_Data_Bear = 8;				
		// ILLEGAL: cannot access private data in SlothBear/Bear
	
	// baloo.protected_Data_Bear = 9;			
		// ILLEGAL: cannot access protected data in SlothBear/Bear
	
	baloo.public_Data_Bear = 10;				
		// OK but inadvisable
	
	//
	//	PROTECTED INHERITANCE: 
	//	Protected and Public data members of Bear are Protected
	//
	PetBear gentleBen;		
	
	// gentleBen.private_Data_Bear = 5;			
		// ILLEGAL: cannot access private data in SlothBear/Bear
	
	// gentleBen.protected_Data_Bear = 9;		
		// ILLEGAL: protected data in PetBear
	
	// PetBear.public_Data_Bear = 10;			
		// ILLEGAL: protected data in PetBear

	//
	//	PROTECTED then PUBLIC INHERITANCE
	//	Protected and Public data members of Bear are Protected
	//
	TeddyBear paddingtonBear;
	// paddingtonBear.private_Data_Bear = 7;	
		// ILLEGAL: cannot access private data in SlothBear/Bear
	
	// paddingtonBear.protected_Data_Bear = 9;	
		// ILLEGAL: cannot access protected data in SlothBear/Bear
	
	// paddingtonBear.public_Data_Bear = 10;	
		// ILLEGAL: public_Data_Bear is protected in TeddyBear

	//
	//	PRIVATE INHERITANCE: 
	//	All data members in Bear are private
	//
	Panda masterPoPing;							

	// masterPoPing.private_Data_Bear = 9;
		// ILLEGAL: cannot access private data in Panda/Bear

	// masterPoPing.protected_Data_Bear = 10;
		// ILLEGAL: cannot access protected data in Panda/Bear

	// masterPoPing.public_Data_Bear = 11;
		// ILLEGAL: cannot access public data in Bear

	//
	cout << endl << "==================="
		 << endl << "END...C++ Demo: Private, Protected Inheritance"
		 << endl;
	while(true){}
	return 0;

}//END...Function main

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
