/*	******************************************************************
	OOP Polymorphism on the Runtime Heap
	******************************************************************
	-	This program demonstrates using Objects based on Polymorphic 
		Classes
		-	Calling Member Functions via POINTERS
			-	The Pointers are of type Pointer-to-BASEclass
			-	Polymorphism takes effect here
			-	The differences between virtual and non-virtual
				functions becomes apparent
*/

#include "Cat.h"
#include "Tiger.h"

#include <iostream>
using namespace std;


int main()
{
	//================================================================
	//	OOP Polymorphism on the Runtime HEAP
	//
	Cat *ptr_Duchess = new Cat();	// Cat twice 
	Cat *ptr_Rajah = new Tiger();

	cout << "===================================" << endl 
		 << "POLYMORPHISM on the Runtime HEAP" << endl
		 << "===================================" << endl;
	//================================================================
	//	(2.1)	Call Member Functions via Pointers
	//
	cout << endl << "=============="
		 << endl << "Calling Member Functions via POINTERS"
		 << endl << "-------"
		 << endl;

	cout << "ptr_Duchess -> greet()\t\t";
	ptr_Duchess -> greet();		//	"Hello from the Cat World"
	
	cout << "ptr_Duchess -> sound()\t\t";
	ptr_Duchess -> sound();		//	"Miaow"
															
	
	cout << "ptr_Rajah -> greet()\t\t";
	ptr_Rajah -> greet();		//	"Hello from the Cat World"	
	
	cout << "ptr_Rajah -> sound()\t\t";
	ptr_Rajah -> sound();		//	"Tiger Roar RRRR"	


	//================================================================
	cout << endl << endl << "===========" << endl 
		 << "END...OOP Polymorphism, Runtime Heap Demo" 
		 << endl;
	while(true){}
	return 0;

}//END...Function main

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
