/*	========================================================================================
	PURE VIRTUAL FUNCTIONS & ABSTRACT CLASSES
	========================================================================================
	-	Abstract Class: used to create a Framework 
		-	Subsuquent classes inherit from this
		-	Result: A project which has a consistent structure/style
	-	Virtual Member Function: used in Polymorphism
		-	Determines which class, Base or Derived, is bound to at RUNTIME
	-	Pure Virtual Member function
		-	= 0 terminology is used
		-	This forces the entire class to be an ABSTRACT class
			-	Cannot create objects of this type 

*/
#include <iostream>
using namespace std;

#ifndef ANIMAL_H
#define ANIMAL_H

class Animal	// Cat is a POLYMORPHIC Base class - it contains a VIRTUAL member function
{
	private:
	public:
		void greet();				//	greet() is NON-VIRTUAL

		// PURE Virtual Function
		virtual void sound(  ) = 0;	//	sound() is VIRTUAL

};//END...Class Animal

#endif

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
