/*	*****************************************************************
	EXCEPTION HANDLING: DIVISION BY ZERO
	*****************************************************************
*/

#include <iostream>
#include <string>
using namespace std;

#include "Exception_DivisionByZero.h"

double calc_Division( double , double ) 
	throw( Exception_DivisionByZero );

int main()
{
	//
	double myDbl_A = 0.0, myDbl_B = 0.0, quotient_A_B = 0.0;
	char userInput = ' ';

	do
	{
		//===========================================================
		cout << endl << "=================================" << endl;
		cout << "Please enter your 1st number: ";
		cin >> myDbl_A;

		cout << "Please enter your 2nd number: ";
		cin >> myDbl_B;

		//===========================================================
		try
		{
			quotient_A_B = calc_Division( myDbl_A, myDbl_B );
			cout << endl
				 << myDbl_A << " divided by " << myDbl_B << " is " 
				 << quotient_A_B 
				 << endl;
		}
		catch( Exception_DivisionByZero& 
				ref_Exception_DivisionByZero_IN 
			 )
		{
			cout << endl << "Exception occurred: " 
				 << ref_Exception_DivisionByZero_IN.what() 
				 << endl;
	
		}//End...try, catch DivisionByZero

		//===========================================================
		cout << "---------" << endl
			 << "Do you want to try again (Y/N)? ";
		cin >> userInput;

	} while( userInput != 'N' ); 
	// End...Do Loop, Request for User Input

	//
	cout << endl << "===============" 
		 << endl << "END...C++ Demo: Exception Handling"
				 << "...Division by Zero"
		 << endl;
	while(true){}
	return 0;

}//END...Function MAIN

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
double calc_Division( double myDbl_IN_A, double myDbl_IN_B )
	throw( Exception_DivisionByZero )
{
	double result = 0.0;
	if( myDbl_IN_B == 0 )
	{
		throw Exception_DivisionByZero();
	}
	else
	{
		result = myDbl_IN_A / myDbl_IN_B;
	}
	return result;

}//END...Function calc_Division

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

