﻿/*	******************************************************************
	EXCEPTION HANDLING: USER INPUT TYPE NOT RECOGNISED
	******************************************************************
*/

#include <iostream>
#include <string>
using namespace std;

#include "Exception_UserInputType.h"

int request_UserEntersInt(string)
throw(Exception_UserInputType);

int main()
{
	int num_People = 0, cost_PerTicket = 0, cost_Total = 0;

	try
	{
		num_People = request_UserEntersInt("the number of people");
		cost_PerTicket = request_UserEntersInt("the cost per ticket");
		cost_Total = num_People * cost_PerTicket;

		cout << "The total cost for " << num_People
			<< " at $" << cost_PerTicket << " per ticket"
			<< " will be $" << cost_Total
			<< endl;

	}
	catch (Exception_UserInputType&
		ref_Exception_UserInputType
		)
	{
		cout << endl << "Exception occurred: "
			<< ref_Exception_UserInputType.what()
			<< endl;

	}//End...try, catch requesting user input

	 //»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	cout << endl << "==============="
		<< endl << "END...C++ Demo: Exception Handling"
		<< "...User Input wrong type"
		<< endl;
	while (true) {}
	return 0;

}//END...Function MAIN


 // Returns default of 0 or the value entered by the user
int request_UserEntersInt(string theRequest)
	throw(Exception_UserInputType)
{
	int myInt_A = 0;
	cout << "Please enter " << theRequest
		<< " then press Return"
		<< endl;

	if (!(cin >> myInt_A))
	{
		throw Exception_UserInputType(); // Call Constructor
	}
	return myInt_A;

}//END...Function request_UserEntersInt

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

