/*	******************************************************************
	Binary File: WRITE/READ PRIMITIVE VARIABLES
	******************************************************************
*/
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

int main()
{
	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	cout << "===============================================" << endl;
	cout << "Binary File: Write/Read Array of Integers" << endl;
	cout << "===============================================" << endl;

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	Creating the Data & WRITING to the Hard Drive
	//
	//----------------------------------------------------------------
	int arrInt_WriteToHD[ ] = { 8, 32, 9, 5, 7, 172, 8192, 12, 16 };
	cout << endl <<"----------------" << endl;
	cout << "Original Data, to be Saved to the Hard Drive:" << endl;
	for( int i = 0; i < ((sizeof(arrInt_WriteToHD)) / (sizeof(int))); ++i )
	{
		cout << arrInt_WriteToHD[i] << " ";
	}

	//----------------------------------------------------------------
	//	WRITING Data, myIntArr, to the Hard Drive
	//	-	Create Output Stream
	//
	ofstream this_ofstream("binaryData_Ints.dat", ios::binary);
	this_ofstream.write( reinterpret_cast<char *>(arrInt_WriteToHD),
							sizeof( arrInt_WriteToHD ) );
	//----------------------------------------------------------------
	this_ofstream.close();
	
	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	READING Data from the Hard Drive
	//	-	Create Input Stream
	//
	int arrInt_ReadFromHD[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

	ifstream this_ifstream("binaryData_Ints.dat", ios::binary);
	this_ifstream.read( reinterpret_cast<char *>(arrInt_ReadFromHD),
					   		sizeof( arrInt_ReadFromHD ) );
	
	cout << endl <<"----------------" << endl;
	cout << "Data Retrieved from Saved File:" << endl;
	for( int i = 0; i < ((sizeof(arrInt_ReadFromHD)) / (sizeof(int))); ++i )
	{
		cout << arrInt_ReadFromHD[i] << " ";
	}
	//----------------------------------------------------------------
	this_ifstream.close();
	
	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	cout	<< endl << endl << "===========" << endl
			<< "END...C++ Demo: Binary Files using Ints"
			<< endl;
	while (true) {}
	return 0;
	
}//END...MAIN Function

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

