/*	******************************************************************
 	Binary File: WRITE/READ SINGLE OBJECTS
 	******************************************************************
 */
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

int main()
{
	cout << "===============================================" << endl;
	cout << "Binary File: Write/Read Single Objects" << endl;
	cout << "===============================================" << endl;

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	WRITING a Single Object to Disk
	//
	cout << "======================================" << endl;
	cout << "Original Data, Writing to Hard Drive" << endl;
	cout << "--------------------------------------" << endl;

	Employee joeBloggs("Joseph Bloggs", "PH 45 67 34 D", 17000.0);
	joeBloggs.greet_AllAttributes();

	ofstream file_WritingEmployeeObject( "Employee_Objs.dat", ios::binary );
	file_WritingEmployeeObject.write( reinterpret_cast<char *>
							  		( &joeBloggs ),
							  	sizeof(joeBloggs) );
	
	// Forgetting to Close will cause Errors...
	file_WritingEmployeeObject.close();

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	READING a Single Object from Disk
	//
	cout << "============================================" << endl;
	cout << "Reading in Employee Object from Hard Disk" << endl;
	cout << "--------------------------------------------" << endl;
	Employee temp_Employee;
	ifstream file_ReadingEmployeeObject("Employee_Objs.dat",
										 ios::binary);
	file_ReadingEmployeeObject.read( reinterpret_cast<char *>
									 		( &temp_Employee),
									  sizeof(temp_Employee) );

	temp_Employee.greet_AllAttributes();

	file_ReadingEmployeeObject.close();

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	cout << endl << endl << "===========" << endl
		<< "END...C++ Demo: Binary File: Write/Read Single Objects"
		<< endl;
	while (true) {}
	return 0;

}// END...MAIN Function

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

