/*	******************************************************************
 	Binary File: WRITE/READ ARRAY OF OBJECTS
 	******************************************************************
 */
#include <fstream>
#include <iostream>
#include <string>
using namespace std;

#include "Employee.h"

int main()
{
	cout << "===============================================" << endl;
	cout << "Binary File: Write/Read Array of Objects" << endl;
	cout << "===============================================" << endl;

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	WRITING Array of Objects to Disk
	//
	cout << "======================================" << endl;
	cout << "Original Data, Writing to Hard Drive" << endl;
	cout << "--------------------------------------" << endl;

	Employee arrEmployee_WriteToHD[] =
		{	Employee("Joseph Bloggs", "PH 45 67 34 D", 17000.0),
			Employee("John Smith", "GH 67 34 67 D", 18000.0),
			Employee("Amanda Taylor", "SG 36 78 24 F", 22000.0)
		};
	
	for( 	int i = 0;
			i < ((sizeof(arrEmployee_WriteToHD))/(sizeof(Employee)));
			++i  )
	{
		arrEmployee_WriteToHD[i].greet_AllAttributes();
	}
	
	//----------------------------------------------------------------
	ofstream this_ofstream("Employee_ArrObjs.dat", ios::binary);
	this_ofstream.write( reinterpret_cast<char *>(arrEmployee_WriteToHD),
						sizeof( arrEmployee_WriteToHD ) );

	//----------------------------------------------------------------
	this_ofstream.close();
	
	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	READING Multiple Objects from Disk
	//
	cout << "============================================" << endl;
	cout << "Reading in Employee Array from Hard Disk" << endl;
	cout << "--------------------------------------------" << endl;

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	//	READING Data from the Hard Drive
	//	-	Create Input Stream
	//
	Employee arrEmployee_ReadFromHD[3];

	ifstream this_ifstream("Employee_ArrObjs.dat", ios::binary);
	this_ifstream.read( reinterpret_cast<char *>(arrEmployee_ReadFromHD),
					   		sizeof( arrEmployee_ReadFromHD ) );
	
	for( int i = 0; i < ((sizeof(arrEmployee_ReadFromHD)) / (sizeof(Employee))); ++i )
	{
		arrEmployee_ReadFromHD[i].greet_AllAttributes();
	}
	
	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	this_ifstream.close();

	//»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»»
	cout << endl << endl << "===========" << endl
		<< "END...C++ Demo: Binary File, Write/Read Array of Objects"
		<< " "
		<< endl;
	while (true) {}
	return 0;

}// END...MAIN Function

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************

