#pragma once
#include "assert.h"

const int SIZE_STACK = 100; 

//
template < typename dataTypeT >
class Stack
{
	private:
		//============================================================
		int count;
		dataTypeT stackArray[SIZE_STACK];

	public:
		//============================================================
		// Initialise the Stack
		Stack()
		{
			count = 0;
		}	
			
		//============================================================
		//	Member Functions - Functionalities of the Stack
		//
		void push( dataTypeT item_In );	// Insertion
		dataTypeT pop();				// Removal
};

//
//	push - Inserting data on to the Stack
//
template <typename dataTypeT>
void Stack<dataTypeT>::push( dataTypeT item_In )
{
	assert( count >= 0 );
	assert( count < sizeof(stackArray) / sizeof( stackArray[0] ) );
	stackArray[count] = item_In;

	++count;

}//END...Member Function Template push

//
//	pop - Removing data from the Stack and returning it
//
template <typename dataTypeT>
dataTypeT Stack<dataTypeT>::pop(  )
{
	--count;
	assert( count >= 0 );
	assert( count < sizeof(stackArray) / sizeof( stackArray[0] ) );

	return stackArray[count]; 

}//END...Member Function Template push

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
