/*	******************************************************************
	C++: TEMPLATES, EXPLICIT SPECIALISATION
	******************************************************************
*/
#include <iostream>
using namespace std;

#include "myClass.h"

int main() 
{
	cout << endl << "==============" << endl;
	cout << "Instantiating with myClass<int,5> myObj_A" 
		 << endl;
	myClass<int,5> myObj_A;
		// Calls: Generic Template i.e. No Specialisation,  myInt_A = 5

	cout << endl << "==============" << endl;
	cout << "Instantiating with myClass<> myObj_B" << endl;
	myClass<> myObj_B;
		// Calls: Explicit specialization (1) called, Parameters: Default
	
	cout << endl << "==============" << endl;
	cout << "Instantiating with myClass<float, 9> myObj_C" 
		 << endl;
	myClass<float, 9> myObj_C;
		// Calls: Explicit specialization (2) called, Parameters: <float, 9>

	cout << endl << "==============" << endl;
	cout << "Instantiating with myClass<float, 9> myObj_D" 
		 << endl;
	myClass<float, 9> myObj_D;
		// Calls: Explicit specialization (2) called, Parameters: <float, 9>

	//
	cout << endl << "==================="
		 << endl << "END...C++ Generics: Class Templates, "
				 << "EXPLICIT/FULL Specialisation" << endl;
	while(true){}
	return 0;

}//END...Function main


//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
