/*	******************************************************************
	CLASS TEMPLATE WITH EXPLICIT SPECIALISATION
	******************************************************************
*/
#pragma once

//####################################################################
// "USUAL/GENERIC" CLASS i.e. NO Specialisation
template<typename T = double, int i = 7> 
class myClass
{
	public:
		myClass();
		int myInt_A;
};

// CONSTRUCTOR: Non Specialist Class
template<typename T, int i> 
myClass<T, i>::myClass() 
	: myInt_A(i)
{
	cout << "Generic Template i.e. No Specialisation, "
		 << " myInt_A = " << myInt_A 
		 << endl;
}

//####################################################################
// EXPLICIT SPECIALISATION 1
template<> 
class myClass<> 
{ 
	public: 
		myClass(); 
};

// CONSTRUCTOR: Specialist Class 1
myClass<>::myClass() 
{
	cout << "Explicit specialization (1) called, "
		 << "Parameters: Default" 
		 << endl;
}

//####################################################################
// EXPLICIT SPECIALISATION 2
template<> 
class myClass<double, 10> 
{ 
	public: 
		myClass(); 
};

// CONSTRUCTOR: Specialist Class 2
myClass<float, 9>::myClass() 
{
	cout << "Explicit specialization (2) called, "
		 << "Parameters: <float, 9>" << endl;
}

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
