/*	******************************************************************
	C++ TEMPLATES: PARTIAL SPECIALISATION
	******************************************************************
	-	This program demonstrates
		-	Creating a Template for generic behaviour (revision)
		-	Partial Specialisation: 
			-	Getting the template to behave differently for
				different numbers/combinations of types
*/
#include <iostream>
using namespace std;

#include "myClass.h"

int main() 
{
	//
	//	"Invoking the various Partial Specialisations"
	//
	myClass<int, int, 7> myObj_A;	// Generic template invoked
	myObj_A.myMemFunc(); 

	myClass<double*, double, 9> myObj_B; 
	myObj_B.myMemFunc();		// Partial specialization 1 invoked

	myClass<double*, char, 10> myObj_C;
	myObj_C.myMemFunc();		// Partial specialization 2 invoked

	myClass<int, double*, 10> myObj_D;
	myObj_D.myMemFunc();		// Partial specialization 3 invoked

	myClass<double, float*, 9> myObj_E;
	myObj_E.myMemFunc();		// 

	// myClass<int, int*, 10> myObj_E;	
		// ERROR: AMBIGUITY: Both Specialisations 3 and 4 match this

	//
	cout << endl << "==================="
		 << endl << "END...C++ Generics: Class Templates, "
				 << "PARTIAL Specialisation" << endl;
	while(true){}
	return 0;

}//END...Function main

//**************************************************************************
//	This software code is from the book Cybernetics in C++
//	by Avi Bhattacharyya,
//	Published by River Publishers
//	All Rights Reserved.
//
//	(C) Copyright River Publishers (2018 onwards)
//
//	-	Permission to use, copy, distribute and sell this software,
//		in whole or in part, is granted on condition this Copyright
//		Statement is included in all copies where any part is
//		present
//	-	The software is provided AS-IS - no recommendations are
//		made for its suitability for any purpose
//	-	No Warranties are given explicitly or implied
//	-	No responsibility is accepted for results obtained following
//		its usage in any way whatsoever
//**************************************************************************
 
